# https://nixos.wiki/wiki/Accelerated_Video_Playback

{ pkgs
, lib
, config
, ... }: with lib; let
  cfg = config.faucet.gui;
in mkIf cfg.enable {
  nixpkgs.config.packageOverrides = pkgs: {
    vaapiIntel = pkgs.vaapiIntel.override { enableHybridCodec = true; };
  };

  hardware.opengl = {
    extraPackages = with pkgs; optionals ((cfg.type == "intel") || (cfg.type == "prime")) [
      intel-media-driver # LIBVA_DRIVER_NAME=iHD
      vaapiIntel         # LIBVA_DRIVER_NAME=i965 (older but works better for Firefox/Chromium)
      vaapiVdpau
      libvdpau-va-gl
    ] ++ optional ((cfg.type == "nvidia") || (cfg.type == "prime")) nvidia-vaapi-driver;
  };
}
